(* -- programme prsent et expliqu dans le livre     *)
(* -- Turbo PASCAL et la programmation OBJET       *)
(* -- de John COLIBRI                                  *)

(* -- disponible  l'INSTITUT PASCAL                   *)
(* -- 26 Rue Lamartine, 75009 PARIS - (16) 42.85.10.82 *)

(* -- (C) Copyright MNEMODYNE 1990                     *)

(*$r+*)

program entier_chaine;
  uses crt, ustream, uentchai;
  var g_choix: char;
      g_entier_chaine: o_entier_chaine;
      g_stream: o_stream;

  procedure cree_et_sauve_exemple;
    var l_choix: char;
    begin
      g_stream.initialise;
      g_entier_chaine.enregistre(g_stream);
      g_stream.cree('a:entchain');
      repeat
        g_entier_chaine.saisis;
        g_stream.met(g_entier_chaine);
        write('  Continuer, Quitter ? '); l_choix:= readkey; writeln(l_choix);
      until l_choix= 'q';
      g_stream.ferme;
    end; 

  procedure charge_et_affiche_exemple;
    begin
      g_stream.initialise;
      g_entier_chaine.enregistre(g_stream);
      g_stream.ouvre('a:entchain');
      while not g_stream.f_fin_fichier do
      begin
        g_stream.retire(g_entier_chaine);
        g_entier_chaine.affiche;
      end; 
      g_stream.ferme;
    end; 

  begin 
    clrscr;
    repeat
      writeln;
      write('Cree et sauve, cHarge et affiche, Quitte ? ');
      g_choix:= readkey; writeln(g_choix);
      case g_choix of
        ' ' : clrscr;
        'c' : cree_et_sauve_exemple;
        'h' : charge_et_affiche_exemple;
      end; 
    until g_choix= 'q';
  end. 
