(* -- programme prsent et expliqu dans le livre     *)
(* -- Turbo PASCAL et la programmation OBJET       *)
(* -- de John COLIBRI                                  *)

(* -- disponible  l'INSTITUT PASCAL                   *)
(* -- 26 Rue Lamartine, 75009 PARIS - (16) 42.85.10.82 *)

(* -- (C) Copyright MNEMODYNE 1990                     *)

(*$r+*)

program objet_avec_procedure_virtuelle;
  (*$i a:ihex *)
  (*$i a:ipointeur *)
  (*$i a:iplanmem *)
  (*$i a:imemoire *)
  type t_string_6= string[6];
       point= object
                x, y: byte;
              end;
       message= object(point)
                  chaine: t_string_6;

                  constructor initialise(p_x, p_y: byte; p_chaine: t_string_6);

                  procedure affiche; virtual;
                end;
       message_couleur= object(message)
                          couleur: byte;

                          constructor initialise(p_x, p_y: byte; p_chaine: t_string_6;
                              p_couleur: byte);
                        end;

  constructor message.initialise(p_x, p_y: byte; p_chaine: t_string_6);
    begin
      x:= p_x; y:= p_y; chaine:= p_chaine;
    end; 

  procedure message.affiche;
    begin
    end;

  constructor message_couleur.initialise(p_x, p_y: byte; p_chaine: t_string_6; p_couleur: byte);
    begin
      x:= p_x; y:= p_y; chaine:= p_chaine; couleur:= p_couleur;
    end; 
  var un_point: point;
      un_message: message;
      un_message_couleur: message_couleur;
      pointeur_table: pointer;

  procedure affiche_objet(var pv_objet; p_taille: integer);
    begin
      affiche_memoire(seg(pv_objet), ofs(pv_objet), ofs(pv_objet)+ p_taille- 1);
    end; 

  procedure affiche_table_procedures_virtuelles(var pv_objet; p_decalage, p_nombre: integer);
    var l_adresse: integer;
    begin
      l_adresse:= memw[seg(pv_objet): ofs(pv_objet)+ p_decalage];
      affiche_memoire(dseg, l_adresse, l_adresse+ 4+ 4* p_nombre- 1);
    end; 

  begin 
    affiche_plan_memoire;
    un_point.x:= $11; un_point.y:= $12;
    affiche_objet(un_point, sizeof(point));
    affiche_objet(un_message, 1+ 1+ 7+ 2);
    un_message.initialise($22, $23, 'PASCAL');
    affiche_objet(un_message, sizeof(un_message));
    un_message_couleur.initialise($33, $34, 'BLAISE', $35);
    affiche_objet(un_message_couleur, sizeof(un_message_couleur));
    affiche_table_procedures_virtuelles(un_message, 1+ 1+ 7, 1);
    affiche_table_procedures_virtuelles(un_message_couleur, 1+ 1+ 7, 1);
    pointeur_table:= typeof(un_message);
    affiche_pointeur(pointeur_table);
  end. 
?

?
?
?

?
?
?

?
?
