(* -- programme prsent et expliqu dans le livre     *)
(* -- Turbo PASCAL et la programmation OBJET       *)
(* -- de John COLIBRI                                  *)

(* -- disponible  l'INSTITUT PASCAL                   *)
(* -- 26 Rue Lamartine, 75009 PARIS - (16) 42.85.10.82 *)

(* -- (C) Copyright MNEMODYNE 1990                     *)

(*$r+*)

program liste_polymorphique_entiers_et_chaines;
  uses crt, ustream, ulistep2, ucellec2;
  var g_choix: char;
      g_liste: o_liste;
      g_stream: o_stream;

  procedure cree_liste;
    begin
      g_liste.initialise;
      g_liste.ajoute_fin(new(t_pt_o_entier, initialise(111)));
      g_liste.ajoute_fin(new(t_pt_o_chaine, initialise('AUTANT')));
      g_liste.ajoute_fin(new(t_pt_o_chaine, initialise('EN EMPORTE LE VENT')));
      g_liste.ajoute_fin(new(t_pt_o_entier, initialise(222)));
    end; 

  procedure sauve_liste;
    var l_entier: o_entier;
        l_chaine: o_chaine;
    begin
      g_stream.initialise;
      g_liste.enregistre(g_stream);
      l_entier.enregistre(g_stream);
      l_chaine.enregistre(g_stream);
      g_stream.cree('a:liste');
      g_stream.met(g_liste);
      g_stream.ferme;
    end; 

  procedure charge_liste;
    var l_entier: o_entier;
        l_chaine: o_chaine;
    begin
      g_stream.initialise;
      g_liste.enregistre(g_stream);
      l_entier.enregistre(g_stream);
      l_chaine.enregistre(g_stream);
      g_stream.ouvre('a:liste');
      g_stream.retire(g_liste);
      g_stream.ferme;
    end; 

  begin 
    clrscr;
    repeat
      writeln;
      write('liste: Cree, Affiche, Sauve, cHarge, Quitte ? ');
      g_choix:= readkey; writeln(g_choix);
      case g_choix of
        ' ' : clrscr;
        'c' : cree_liste;
        'a' : g_liste.affiche;
        's' : sauve_liste;
        'h' : charge_liste;
      end; 
    until g_choix= 'q';
  end. 
