(* -- programme prsent et expliqu dans le livre     *)
(* -- Turbo PASCAL et la programmation OBJET       *)
(* -- de John COLIBRI                                  *)

(* -- disponible  l'INSTITUT PASCAL                   *)
(* -- 26 Rue Lamartine, 75009 PARIS - (16) 42.85.10.82 *)

(* -- (C) Copyright MNEMODYNE 1990                     *)


program objet_pointe;
  uses crt;
  TYPE t_pt_pile= ^t_pile;
       t_pile= OBJECT
                 nombre_elements: INTEGER;
                 taille_max: INTEGER;
                 tableau: ARRAY[0..100] OF INTEGER;
                 PROCEDURE dimensionne(p_taille_max: INTEGER);
                 FUNCTION vide: BOOLEAN;
                 FUNCTION pleine: BOOLEAN;
                 FUNCTION retire: INTEGER;
                 PROCEDURE pousse(p_element: INTEGER);
               END;
  PROCEDURE t_pile.dimensionne(p_taille_max: INTEGER);
    BEGIN
      taille_max:= p_taille_max;
      nombre_elements:= 0;
    END; 
  FUNCTION t_pile.vide: BOOLEAN;
    BEGIN
      vide:= nombre_elements= 0;
    END; 
  FUNCTION t_pile.pleine: BOOLEAN;
    BEGIN
      pleine:= nombre_elements= taille_max;
    END; 
  FUNCTION t_pile.retire: INTEGER;
    BEGIN
      IF NOT vide
         THEN BEGIN
             retire:= tableau[nombre_elements];
             nombre_elements:= nombre_elements- 1;
           END;
    END; 
  PROCEDURE t_pile.pousse(p_element: INTEGER);
    BEGIN
      IF NOT pleine
        THEN BEGIN
            nombre_elements:= nombre_elements+ 1;
            tableau[nombre_elements]:= p_element;
          END;
    END; 
  VAR la_pile: t_pt_pile;
  BEGIN 
    clrscr;
    NEW(la_pile);
    la_pile^.dimensionne(10);
    la_pile^.pousse(9); la_pile^.pousse(8); la_pile^.pousse(7);
    WHILE NOT la_pile^.vide DO
      WRITELN(la_pile^.retire);
    dispose(la_pile);
    readln;
  END.
?
?
