(* -- programme prsent et expliqu dans le livre     *)
(* -- Turbo PASCAL et la programmation OBJET       *)
(* -- de John COLIBRI                                  *)

(* -- disponible  l'INSTITUT PASCAL                   *)
(* -- 26 Rue Lamartine, 75009 PARIS - (16) 42.85.10.82 *)

(* -- (C) Copyright MNEMODYNE 1990                     *)

(*$r+*)

program pile_dynamique;
  uses crt;
  type t_pt_o_cellule = ^o_cellule;
       o_cellule = object
                     entier: integer;
                     pt_suivante: t_pt_o_cellule;

                     constructor cree;

                     procedure affiche; virtual;

                     destructor libere;
                   end;
         o_pile = object
                    pt_debut_pile: t_pt_o_cellule;
                    PROCEDURE initialise;
                    FUNCTION vide: BOOLEAN;
                    PROCEDURE pousse(p_element: INTEGER);
                    FUNCTION retire: INTEGER;

                    procedure affiche_pile;
                  END;

  constructor o_cellule.cree;
    begin
    end; 

  procedure o_cellule.affiche;
    var l_pt_o_cellule: t_pt_o_cellule;
    BEGIN
      write(entier, ' ');
    end; 

  destructor o_cellule.libere;
    begin
    end; 
  PROCEDURE o_pile.initialise;
    BEGIN
      pt_debut_pile:= nil;
    END; 
  FUNCTION o_pile.vide: BOOLEAN;
    BEGIN
      vide:= pt_debut_pile= nil;
    END; 
  PROCEDURE o_pile.pousse(p_element: INTEGER);
    var l_pt_o_cellule: t_pt_o_cellule;
    BEGIN
      new(l_pt_o_cellule);
      l_pt_o_cellule^.cree;
      with l_pt_o_cellule^ do

      begin
        entier:= p_element;
        pt_suivante:= pt_debut_pile;
      end;
      pt_debut_pile:= l_pt_o_cellule;
    END; 
  FUNCTION o_pile.retire: INTEGER;
    var l_pt_o_cellule: t_pt_o_cellule;
    BEGIN
      IF NOT vide
         THEN BEGIN
             retire:= pt_debut_pile^.entier;
             l_pt_o_cellule:= pt_debut_pile;
             pt_debut_pile:= pt_debut_pile^.pt_suivante;
             dispose(l_pt_o_cellule, libere);
           END;
    END; 

  procedure o_pile.affiche_pile;
    var l_pt_o_cellule: t_pt_o_cellule;
    BEGIN
      l_pt_o_cellule:= pt_debut_pile;
      while l_pt_o_cellule<> nil do
      begin
        l_pt_o_cellule^.affiche;
        l_pt_o_cellule:= l_pt_o_cellule^.pt_suivante;
      end;
    end; 
  VAR la_pile: o_pile;
  BEGIN 
    clrscr;
    la_pile.initialise;
    la_pile.pousse(9); la_pile.pousse(8); la_pile.pousse(7);
    la_pile.affiche_pile; writeln;
    WHILE NOT la_pile.vide DO
      WRITELN(la_pile.retire);
    readln;
  END. 

?
?
?

?
?
?

?
?
?

?
?
?

?
?
