(* -- programme prsent et expliqu dans le livre     *)
(* -- Turbo PASCAL et la programmation OBJET       *)
(* -- de John COLIBRI                                  *)

(* -- disponible  l'INSTITUT PASCAL                   *)
(* -- 26 Rue Lamartine, 75009 PARIS - (16) 42.85.10.82 *)

(* -- (C) Copyright MNEMODYNE 1990                     *)

(*$r+*)
unit uentchai;
  interface
    uses ustream, uentier;
    type t_pt_o_entier_chaine= ^o_entier_chaine;
         o_entier_chaine= object(o_entier)
                            chaine: string;

                            constructor saisis;

                            procedure affiche;

                            procedure enregistre(var pv_o_stream: o_stream);

                            procedure sauve(var pv_o_stream: o_stream);

                            constructor charge(var pv_o_stream: o_stream);
                          end;
  implementation

    constructor o_entier_chaine.saisis;
      begin
        o_entier.saisis;
        write('  chaine ? '); readln(chaine);
      end; 

    procedure o_entier_chaine.affiche;
      begin
        o_entier.affiche;
        writeln('chaine: ', chaine);
      end; 

    procedure o_entier_chaine.enregistre(var pv_o_stream: o_stream);
      begin
        o_entier.enregistre(pv_o_stream);
        pv_o_stream.enregistre(2, typeof(o_entier_chaine),
            @o_entier_chaine.sauve, @o_entier_chaine.charge);
      end; 

    procedure o_entier_chaine.sauve(var pv_o_stream: o_stream);
      begin
        o_entier.sauve(pv_o_stream);
        pv_o_stream.ecris_disque(chaine, length(chaine)+ 1);
      end; 

    constructor o_entier_chaine.charge(var pv_o_stream: o_stream);
      var l_taille: byte;
      begin
        o_entier.charge(pv_o_stream);
        pv_o_stream.lis_disque(l_taille, 1);
        pv_o_stream.lis_disque(chaine[1], l_taille);
        chaine[0]:= chr(l_taille);
      end; 

    begin 
    end. 
?

?
?
?

?
?
?

?
?
?

?
?
