(* -- programme prsent et expliqu dans le livre     *)
(* -- Turbo PASCAL et la programmation OBJET       *)
(* -- de John COLIBRI                                  *)

(* -- disponible  l'INSTITUT PASCAL                   *)
(* -- 26 Rue Lamartine, 75009 PARIS - (16) 42.85.10.82 *)

(* -- (C) Copyright MNEMODYNE 1990                     *)

(*$r+*)
unit ulistep2;
  interface
    uses ustream;
    type t_pt_o_cellule = ^o_cellule;
         o_cellule = object(o_base)
                       pt_suivante: t_pt_o_cellule;

                       procedure affiche; virtual;
                     end;
         o_liste = object(o_base)
                     pt_debut_liste, pt_fin_liste: t_pt_o_cellule;
                     nombre: integer;

                     constructor initialise;

                     constructor init2;

                     procedure ajoute_fin(p_pt_o_cellule: t_pt_o_cellule);

                     procedure affiche;

                     procedure enregistre(var pv_o_stream: o_stream);

                     procedure sauve(var pv_o_stream: o_stream);

                     constructor charge(var pv_o_stream: o_stream);
                   end;
  implementation

    procedure o_cellule.affiche;
      begin
      end; 

    constructor o_liste.init2;
      begin
      end;

    constructor o_liste.initialise;
      begin
        pt_debut_liste:= nil;
        nombre:= 0;
      end; 

    procedure o_liste.ajoute_fin(p_pt_o_cellule: t_pt_o_cellule);
      begin
        p_pt_o_cellule^.pt_suivante:= nil;
        if pt_debut_liste = nil
          then pt_debut_liste := p_pt_o_cellule
          else pt_fin_liste^.pt_suivante := p_pt_o_cellule;
        pt_fin_liste := p_pt_o_cellule;
        nombre:= nombre+ 1;
      end; 

    procedure o_liste.affiche;
      var l_pt_courant: t_pt_o_cellule;
      begin
        l_pt_courant:= pt_debut_liste;
        while l_pt_courant<> nil do
        begin
          l_pt_courant^.affiche;
          l_pt_courant:= l_pt_courant^.pt_suivante;
        end;
      end; 

    procedure o_liste.enregistre(var pv_o_stream: o_stream);
      begin
        pv_o_stream.enregistre(3, typeof(o_liste), @o_liste.sauve, @o_liste.charge);
      end; 

    procedure o_liste.sauve(var pv_o_stream: o_stream);
      var l_pt_courant: t_pt_o_cellule;
      begin
        pv_o_stream.ecris_disque(nombre, 2);
        l_pt_courant:= pt_debut_liste;
        while l_pt_courant<> nil do
        begin
          pv_o_stream.met(l_pt_courant^);
          l_pt_courant:= l_pt_courant^.pt_suivante;
        end;
      end; 

    constructor o_liste.charge(var pv_o_stream: o_stream);
      var l_pt_courant: t_pt_o_cellule;
          l_nombre: integer;
      begin
        initialise;
        pv_o_stream.lis_disque(nombre, 2);
        for l_nombre:= 1 to nombre do
        begin
          l_pt_courant:= t_pt_o_cellule(pv_o_stream.f_alloue_et_retire);
          if l_pt_courant<> nil
            then ajoute_fin(l_pt_courant);
        end;
      end; 

    begin 
    end. 
?

?
?
?

?
?
?

?
?
?

?
?
?

?
?
?

?
?
?

?
?
