(* -- programme prsent et expliqu dans le livre     *)
(* -- Turbo PASCAL et la programmation OBJET       *)
(* -- de John COLIBRI                                  *)

(* -- disponible  l'INSTITUT PASCAL                   *)
(* -- 26 Rue Lamartine, 75009 PARIS - (16) 42.85.10.82 *)

(* -- (C) Copyright MNEMODYNE 1990                     *)


program debugger_independant;
  type o_point= object
                  x, y: integer;

                  constructor initialise(p_x, p_y: integer);

                  procedure deplace(p_deplacement: integer);

                  procedure affiche; virtual;
                end;
       o_cercle= object(o_point)
                   rayon: integer;

                   procedure initialise(p_rayon: integer);
                 end;
       o_cylindre= object(o_cercle)
                     parametres: record
                                   hauteur: integer;
                                   temperature: array[0..23] of real;
                                 end;

                     procedure initialise(p_hauteur: integer);
                   end;
       o_rectangle= object(o_point)
                      largeur: integer;
                      cercle_inscrit: o_cercle;

                      procedure initialise(p_largeur: integer);
                    end;

  constructor o_point.initialise(p_x, p_y: integer);
    begin
      x:= p_x; y:= p_y;
    end; 

  procedure o_point.deplace(p_deplacement: integer);
    var l_deplacement: integer;

    procedure calcule;
      begin
        l_deplacement:= 2* p_deplacement;
      end; 

    begin 
      calcule;
    end; 

  procedure o_point.affiche;
    begin
      writeln(x, ' ', y);
    end; 

  procedure o_cercle.initialise(p_rayon: integer);
    begin
      rayon:= p_rayon;
    end; 

  procedure o_cylindre.initialise(p_hauteur: integer);
    begin
      parametres.hauteur:= p_hauteur;
    end; 

  procedure o_rectangle.initialise(p_largeur: integer);
    begin
      largeur:= p_largeur;
    end; 
  var un_point: o_point;
      un_cercle: o_cercle;
      un_cylindre: o_cylindre;
      un_rectangle: o_rectangle;

  procedure essai;
    begin
      un_point.initialise($11, $22);
      un_point.affiche;
      un_point.deplace(2);
      un_cercle.initialise($33);
      un_cylindre.initialise($44);
      un_rectangle.initialise($55);
    end; 

  begin 
    essai;
  end. 
?

?
?
?

?
?
?

?
?
?

?
?
?

?
?
?

?
?
