(* -- programme prsent et expliqu dans le livre     *)
(* -- Turbo PASCAL et la programmation OBJET       *)
(* -- de John COLIBRI                                  *)

(* -- disponible  l'INSTITUT PASCAL                   *)
(* -- 26 Rue Lamartine, 75009 PARIS - (16) 42.85.10.82 *)

(* -- (C) Copyright MNEMODYNE 1990                     *)

(*$r+*)

program dessin_avec_une_liste_chainee;
  uses crt, liste;
  type t_pt_o_point= ^o_point;
       o_point= object(o_cellule)
                  y, x: integer;

                  constructor initialise_point(x_debut, y_debut: integer);

                  procedure affiche; virtual;
                end;

  constructor o_point.initialise_point(x_debut, y_debut: integer);
    begin
      x:= x_debut;
      y:= y_debut;
    end; 

  procedure o_point.affiche;
    begin
      writeln('x= ', x, ', y= ', y);
    end; 
  var ligne_brisee: o_liste;

  procedure affiche_dessin;
    var l_pt_o_point: t_pt_o_point;
    begin
      l_pt_o_point:= t_pt_o_point(ligne_brisee.f_premiere_cellule);
      while l_pt_o_point<> nil do
      begin
        l_pt_o_point^.affiche;
        l_pt_o_point:= t_pt_o_point(ligne_brisee.f_cellule_suivante(l_pt_o_point));
      end;
    end; 

  begin 
    clrscr;
    ligne_brisee.initialise_liste;
    ligne_brisee.ajoute_fin( new(t_pt_o_point, initialise_point(5, 5)) );
    ligne_brisee.ajoute_fin( new(t_pt_o_point, initialise_point(6, 6)) );
    ligne_brisee.ajoute_fin( new(t_pt_o_point, initialise_point(7, 7)) );
    affiche_dessin;
    ligne_brisee.supprime_liste;
    readln;
   end. 
?

?
?
?

?
?
