(* -- programme prsent et expliqu dans le livre     *)
(* -- Turbo PASCAL et la programmation OBJET       *)
(* -- de John COLIBRI                                  *)

(* -- disponible  l'INSTITUT PASCAL                   *)
(* -- 26 Rue Lamartine, 75009 PARIS - (16) 42.85.10.82 *)

(* -- (C) Copyright MNEMODYNE 1990                     *)

(*$r+*)

program fichier_et_objets_avec_procedure_virtuelle;
  uses crt;
  type nombre= object
                 valeur: integer;
                 titre: string;

                 constructor initialise(p_nombre: integer; p_titre: string);

                 constructor initialise_vecteur;

                 procedure affiche; virtual;
               end;

  constructor nombre.initialise(p_nombre: integer; p_titre: string);
    begin
      valeur:= p_nombre;
      titre:= p_titre;
    end; 

  procedure nombre.affiche;
    begin
      writeln(valeur, ' = ', titre);
    end; 

  constructor nombre.initialise_vecteur;
    begin
    end;

  procedure ecris_objet(var pv_fichier: file; var pv_donnee; p_taille: integer);
    begin
      blockwrite(pv_fichier, pv_donnee, p_taille);
    end; 

  procedure lis_objet(var pv_fichier: file; var pv_donnee; p_taille: integer);
    begin
      blockread(pv_fichier, pv_donnee, p_taille);
    end; 
  var choix: char;
      tableau_nombres: array[1..5] of nombre;
      fichier: file;

  procedure cree_tableau;
    begin
      tableau_nombres[1].initialise(1, 'UN');
      tableau_nombres[2].initialise(2, 'DEUX');
      tableau_nombres[3].initialise(3, 'TROIS');
      tableau_nombres[4].initialise(4, 'QUATRE');
      tableau_nombres[5].initialise(5, 'CINQ');
    end; 

  procedure sauve_tableau;
    var l_indice: integer;
    begin
      assign(fichier, 'entier.dta');
      rewrite(fichier, 1);
      for l_indice:= 1 to 5 do
        ecris_objet(fichier, tableau_nombres[l_indice], sizeof(nombre));
      close(fichier);
    end; 

  procedure charge_tableau;
    var l_indice: integer;
    begin
      assign(fichier, 'entier.dta');
      reset(fichier, 1);
      l_indice:= 1;
      while not eof(fichier) do
      begin
        lis_objet(fichier, tableau_nombres[l_indice], sizeof(nombre));
        tableau_nombres[l_indice].initialise_vecteur;
        l_indice:= l_indice+ 1;
      end;
      close(fichier);
    end; 

  procedure affiche_tableau;
    var l_indice: integer;
    begin
      for l_indice:= 1 to 5 do
        tableau_nombres[l_indice].affiche;
    end; 

  begin 
    clrscr;
    repeat
      write('Cre, Affiche, Ecris, Relis, Sizeof, Quitte ? ');
      choix:= readkey; writeln(choix);
      case choix of
        'a' : affiche_tableau;
        'c' : cree_tableau;
        'e' : sauve_tableau;
        'r' : charge_tableau;
        's' : writeln(sizeof(nombre), ' ', sizeof(tableau_nombres[1]));
      end;
    until choix= 'q';
  end. 
?

?
?
?

?
?
?

?
?
