(* -- programme prsent et expliqu dans le livre     *)
(* -- Turbo PASCAL et la programmation OBJET       *)
(* -- de John COLIBRI                                  *)

(* -- disponible  l'INSTITUT PASCAL                   *)
(* -- 26 Rue Lamartine, 75009 PARIS - (16) 42.85.10.82 *)

(* -- (C) Copyright MNEMODYNE 1990                     *)

(*$r+*)

program objet_polymorphique;
  uses crt, liste;
  type t_pt_o_rectangle= ^o_rectangle;
       o_rectangle= object(o_cellule)
                      longueur, largeur: integer;

                      constructor initialise(p_longueur, p_largeur: integer);

                      procedure affiche; virtual;
                    end;
       t_pt_o_carre= ^o_carre;
       o_carre= object(o_rectangle)
                  cote: integer;

                  constructor initialise(p_cote: integer);

                  procedure affiche; virtual;
                end;

  constructor o_rectangle.initialise(p_longueur, p_largeur: integer);
    begin
      longueur:= p_longueur;
      largeur:= p_largeur;
    end; 

  procedure o_rectangle.affiche;
    begin
      writeln('longueur= ', longueur, ', largeur= ', largeur);
    end; 

  constructor o_carre.initialise(p_cote: integer);
    begin
      o_rectangle.initialise(p_cote, p_cote);
      cote:= p_cote;
    end; 

  procedure o_carre.affiche;
    begin
      writeln('cote= ', cote);
    end; 
  var dessin: o_liste;

  procedure affiche_dessin;
    var l_pt_o_rectangle: t_pt_o_rectangle;
    begin
      l_pt_o_rectangle:= t_pt_o_rectangle(dessin.f_premiere_cellule);
      while l_pt_o_rectangle<> nil do
      begin
        l_pt_o_rectangle^.affiche;
        l_pt_o_rectangle:= t_pt_o_rectangle(dessin.f_cellule_suivante(l_pt_o_rectangle));
      end;
    end; 

  begin 
    clrscr;
    dessin.initialise_liste;
    dessin.ajoute_fin( new(t_pt_o_rectangle, initialise(5, 15)) );
    dessin.ajoute_fin( new(t_pt_o_carre, initialise(16)) );
    dessin.ajoute_fin( new(t_pt_o_rectangle, initialise(7, 27)) );
    affiche_dessin;
    dessin.supprime_liste;
    readln;
   end. 
?

?
?
?

?
?
?

?
?
?

?
?
