(* -- programme prsent et expliqu dans le livre     *)
(* -- Turbo PASCAL et la programmation OBJET       *)
(* -- de John COLIBRI                                  *)

(* -- disponible  l'INSTITUT PASCAL                   *)
(* -- 26 Rue Lamartine, 75009 PARIS - (16) 42.85.10.82 *)

(* -- (C) Copyright MNEMODYNE 1990                     *)

unit ucellec2;
  interface
    uses ustream, ulistep2;
    type 
         t_pt_o_entier= ^o_entier;
         o_entier= object(o_cellule)
                     entier: integer;

                     constructor initialise(p_entier: integer);

                     procedure affiche; virtual;

                     procedure enregistre(var pv_o_stream: o_stream);

                     procedure sauve(var pv_o_stream: o_stream);

                     constructor charge(var pv_o_stream: o_stream);
                   end;
         t_pt_o_chaine= ^o_chaine;
         o_chaine= object(o_cellule)
                     chaine: string;

                     constructor initialise(p_chaine: string);

                     procedure affiche; virtual;

                     procedure enregistre(var pv_o_stream: o_stream);

                     procedure sauve(var pv_o_stream: o_stream);

                     constructor charge(var pv_o_stream: o_stream);
                   end;
  implementation

    constructor o_entier.initialise(p_entier: integer);
      begin
        entier:= p_entier;
      end; 

    procedure o_entier.affiche;
      begin
        writeln('  entier: ', entier);
      end; 

    procedure o_entier.enregistre(var pv_o_stream: o_stream);
      begin
        pv_o_stream.enregistre(4, typeof(o_entier), @o_entier.sauve, @o_entier.charge);
      end; 

    procedure o_entier.sauve(var pv_o_stream: o_stream);
      begin
        pv_o_stream.ecris_disque(entier, 2);
      end; 

    constructor o_entier.charge(var pv_o_stream: o_stream);
      begin
        pv_o_stream.lis_disque(entier, 2);
      end; 

    constructor o_chaine.initialise(p_chaine: string);
      begin
        chaine:= p_chaine;
      end; 

    procedure o_chaine.affiche;
      begin
        writeln('  chaine: ', chaine);
      end; 

    procedure o_chaine.enregistre(var pv_o_stream: o_stream);
      begin
        pv_o_stream.enregistre(5, typeof(o_chaine), @o_chaine.sauve, @o_chaine.charge);
      end; 

    procedure o_chaine.sauve(var pv_o_stream: o_stream);
      begin
        pv_o_stream.ecris_disque(chaine, length(chaine)+ 1);
      end; 

    constructor o_chaine.charge(var pv_o_stream: o_stream);
       var l_taille: byte;
       begin
         pv_o_stream.lis_disque(l_taille, 1);
         pv_o_stream.lis_disque(chaine[1], l_taille);
         chaine[0]:= chr(l_taille);
       end; 

    begin 
    end. 
?

?
?
?

?
?
?

?
?
?

?
?
?

?
?
?

?
?
?

?
?
?

?
?
?

?
?
